---
{
.title = "CV / Résumé",
.date = @date("2024-05-20T00:00:00"),
.author = "koehr",
.draft = false,
.layout = "page.html",
.description = "My Curriculum Vitae / Résumé. I know, there is a difference. This page is technically a résumé, while the whole site would be closer to a CV.",
.tags = [],
}
---
In me you will find an enthusiastic, passionate developer with around 13 years of professional experience in and around software development, mainly full-stack web development and consulting, but also coaching and community work. I strive to seek roles in creative, forward thinking companies with diverse teams that offer challenging work, trust and responsibility. Since 2022 I'm the principal frontend engineer and frontend chapter lead of [Code Gaia](https://codegaia.io).


## Principal Frontend Engineer, Code Gaia

> Gode Gaia GmbH, Munich / remote (since August 2022)

### Main responsibilities

* leading the frontend chapter
* defining development processes and standards
* team management responsibilities
* lead complete rewrite of frontend
* interviewing potential new hires

### Key Technologies

* Javascript/Typescript: Vue3 with Composition API
* AWS Amplify
* AWS Bedrock

### Noteworthy aspects

* AI integration (LLM as well as document scanning and categorization)
* Python / Django backend
* 100% remote work

---

## Senior Software Engineer, Coursedog

> Coursedog Inc, New York / remote (June 2021 till June 2022)

### Main responsibilities

* frontend introduction and contact for newcomers
* maintainance/bug fixing for existing features
* development of multiple new features
* introduced Docker to ease developer onboarding
* lead the frontend-part of feature flags introduction
* being part of the Typescript transition team

### Key Technologies

* Javascript/Typescript: Vue2 with Composition API
* Node: Express, Fastify

### Noteworthy aspects

* Large codebase (~450k SLOC in total)
* 100% remote work

---

## Senior Consultant, Wunderdog

> Wunderdog GmbH, Helsinki / Berlin / remote (June 2018 till June 2021)

### Main responsibilities

* Consultant work with lots of different clients
* including leadership roles, hiring and building new teams
* enhancing existing teams or on my own
* in companies ranging from 1000s of employees to small startups
* sectors include retail, sports, travel, entertainment, HR
* doing feature development for large, medium and small as well as greenfield projects

### Key Technologies

* Javascript/Typescript: Vue, React, Ember
* Node: Express, Koa, Featherjs
* Ruby: Ruby on Rails, Sinatra
* AWS, GCP

### Noteworthy aspects

* Wide variety of projects and companies
* Greenfield projects as well as existing code bases

---

## Senior Software Engineer, HERE

> HERE Global BV, Berlin (November 2017 till March 2018)

### Main responsibilities

* planning and implementation of a web based floor plan and indoor navigation system with touch controls and full access control system
* integration of meeting room related functionality into Office 365

### Key Technologies

* Javascript: Vue, SVG, MapGL
* Node: Express
* IOT: Bluetooth controlled sensors
* Azure Cloud and Microsoft Office 365 integration

---

## Senior Software Engineer, FromAtoB
> FromAtoB GmbH, Berlin (August 2016 till September 2017)

### Main responsibilities

* development of a single-page application in the travel sector
* lead the introduction of Vue into the process
* rebuilt complete website funnel and replaced old application step-by-step
* while maintaining the Ruby-on-Rails based web application
* implemented internal tooling in Rust

### Key Technologies

* Javascript/Typescript (Vuejs)
* Ruby (Ruby on Rails)
* Rust

---

## Software Engineer (freelancing)

> Berlin, remote (June 2015 till August 2017)

### Clients (selection)

* Zalando (Retail, frontend-development with React)
* Camunda (BPMN.io, open-source web-based BPMN modeler and rendering toolkit, Javascript, SVG)
* Blacklane (Ride service, web-based booking system, AngularJS, Node Express)

### Key Technologies

* Javascript/Typescript: Vue, React, AngularJS
* Node: Express

---

## Software Engineer, HERE

> HERE Global BV, Berlin (November 2013 till May 2015)

### Main responsibilities

* implementation of a mapping and discovery web-application
* map-tile loading optimization
* path rendering
* POI proximity search

### Key Technologies

* Javascript/Typescript: Vue, React, Ember
* Node: Express, Koa, Featherjs
* Ruby: Ruby on Rails, Sinatra

---

## Software Engineer (freelancing)

> Leipzig, Berlin, remote (October 2009 till October 2013)

### Clients (selection)

* Coreon (Taxonomy management, web-based editor, Javascript, Backbone, SVG, Ruby on Rails)
* Wimdu (Travel web-application, live search, Javascript, Backbone, Ruby on Rails, ElasticSearch
* Appzonaut / Telekom Innovation Labs (experimental UI for multi-cloud management, Javascript, Backbone, SVG, Python, Flask

### Key Technologies

* Javascript: Backbone, AngularJS
* Ruby: Ruby on Rails, Sinatra / Padrino
* Python: Flask
* SVG, HTML5, CSS3
* CouchDB, MongoDB

