---
{
.title = "Projects",
.date = @date("2024-05-17T00:00:00"),
.author = "koehr",
.draft = false,
.layout = "page.html",
.description = "My currently active projects. This is mostly about software, but might also include some TTRPG stuff, from time to time.",
.tags = [],
}
---
## Homepage Overhaul

> With lots of work comes lots of opportunity for productive procrastination

Not too long ago, .ing <span title="Top Level Domain">TLDs</span> became available, that allowed me to finally have my full name as a "cool" domain name: `koehr.ing`. Other domains I have are `nkoehring.de` (boring), `koehr.in` (confusing) and `k0r.in` (nerdy). `koehri.ng` wouldn't be possible due to domain registars policies or pricing (Nigeria used to have the british model, like allowing only net.ng, com.ng, and so on. Later they allowed more, but the price would be pretty high).

Why am I writing all this? Because the new domain name made me think about my homepage as a professional. I wanted to have something, that showcases my skills while not being the usual boring homepage. This is how [the interactive homepage experiment](https://cli.koehr.ing) began; a terminal like website, written from scratch. Having this, I now also needed to change my old homepage to somehow feature my new shiny experiment. But my old homepage is white and not very responsive; two very good reasons (for me), to change it. So I also started writing a completely new homepage, using [vss](https://github.com/vssio/vss). Pretty soon I realised, it is by far not mature enough for my needs, so I started building workarounds to suit my needs, so I don't get stuck in the rabbit hole of choosing frameworks over finishing the page. My plan is, to finish the page and its content and then, when there is time, move it on top of something more sophisticated, like good ol' [Zola](https://www.getzola.org/).

## New Server

I found a pretty cheap dedicated server with tons of space and quite some CPU power, compared to cheap virtual servers. Now I need to move everything I hosted on a VServer before. That is not a simple task, unfortunately, as I tend to overthink and want to use the change to make everything better (or just different, maybe). This move includes a switch from [Docker](https://www.docker.com/) and [systemd services](https://blog.container-solutions.com/running-docker-containers-with-systemd) to [podman](https://podman.io/) and [lingering users](https://wiki.archlinux.org/title/Systemd/User#Automatic_start-up_of_systemd_user_instances). This way, no root enabled service is involved in running any outside-facing services. This website and everything under the koehr.ing domain runs already on the new server.

## learned.today

Quite a while (aka way too long) ago, I bought the domain `learned.today` and thought about some idea around a Today I learned page or service, where people just share short snippets of things they just learned, similar to [my TIL page](/til). I never got to implementing it though. I wrote it down here as a motivation for myself, to finally work on it.
